<?php

if (defined("_INC_PUBLIC")) {
  // cas de l'inclusion d'un squelette,
  // include PHP dj faits, mais il faut simuler une SERVER[REQUEST_URI]
  // pour que le md5 du cache soit le meme qu'un appel initial cf ci-dessous

  $appel = substr($GLOBALS[PHP_SELF],0, strrpos($GLOBALS[PHP_SELF], '/')+1) .
    $fond;
  spip_log("inclure: $appel");
  if (is_array($contexte_inclus)) {
    reset($contexte_inclus);
    while(list($k, $v) = each($contexte_inclus)) $appel .= "=$v";
  }
  $hache = md5($appel);
  $page = '';
  if (($GLOBALS['recalcul'] != 'oui') && empty($HTTP_POST_VARS))
    $page = ramener_cache($hache, 'page_obsolete', 'spip_caches');
  if (!$page)
    {  
    $page = cherche_page($fond, $hache, $contexte_inclus);
    ecrire_cache($appel, $hache, $page[0], $page[1], $delais);
    $page = $page[0];
    }
  envoi_page($page, $admin, $use_cache);

  // tout le reste du fichier concerne le cas initial
} else {
  define("_INC_PUBLIC", "1");
  include ("ecrire/inc_version.php3");
  include_ecrire("inc_meta.php3");
  if (!$GLOBALS['db_ok'])
    die ("<h4>"._T('titre_probleme_technique')."</h4>"); 
  if ($INSECURE['fond'] || $INSECURE['delais']) exit;
  if (!isset($delais)) $delais = 1 * 3600;
  if ($HTTP_COOKIE_VARS['spip_session'] OR $PHP_AUTH_USER) {
    include_ecrire ("inc_session.php3");
    verifier_visiteur();
  }

function envoi_page($page, $admin, $cached)
{

 // insertion du JS juste avant la balise </head>, 
 // s'il n'y en a pas, on ne fait rien, en esprant un include qui l'aura

 if ($p = stristr($page, "</head"))

   {
 // Le bouton des administrateurs est affich par une fonction JavaScript
 // non mise en cache car dpendant de l'utilisateur (pas d'affichage parfois)
 // Elle est appele par le code d'un squelette utilisant FORMULAIRE_ADMIN
 // Elle est aussi appele d'autorit si flag_preserver est Vrai,
 // aussi elle se neutralise au premier appel pour ne pas afficher 2 fois.
     
     if  ($admin)
       {
	 include_local('inc-admin.php3');
	 $admin = addslashes(str_replace("\n", ' ', 
			 afficher_boutons_admin($cached ? ' *' : '')));
       }

     $page = substr($page,0,strlen($page)-strlen($p)) .
      "<script language='text/javascript'><!--
	bouton_admin = \"" .
      $admin .
      "\"
	function admin() {document.write(bouton_admin); bouton_admin=''}" .
      "\n//--></script>\n" .
       $p;
   }

 if ($flag_preserver && ($p = stripos($page, "</body")))
   $page .= "<script language='text/javascript'><!--\nadmin()\n//--></script>";

 eval('?' . '>' .  $page);
// inutile de faire attendre plus longtemps
 flush();
}

// Une petite fonction de trace qui devrait etre dans inc_db_mysql

function spip_query_log($r)
{
  $l = spip_query($r); 
#  $e = mysql_info(); # absent de certaines versions de MySQL
  spip_log($SERVER[REQUEST_URI] . $r .  $e);
  return $l;
}

// ajout_forum est une HTTP_GET_VAR installe par retour_forum dans inc-forum.
// Il s'agit de pirater la REQUEST_URI du formulaire, afin de mettre en base
// les valeurs transmises, avant raffichage du formulaire avec celles-ci.
// En cas de validation finale on redirige vers l'URL ayant provoqu l'appel
// au lieu de laisser l'URL appele resynthtiser le formulaire.
  if ($ajout_forum) {
    $redirect = '';
    include('inc-messforum.php3');
    if ($redirect)
      {
	@header("Location: $redirect");
	exit;
      }
#    include('inc-forum.php3'); pour plus tard
  }
  
// nettoyage de l'URL pour avoir un nom de cache compatible avec les include

  $appel = eregi_replace('.php3?\??','&', $PHP_SELF);
spip_log("nom de cache: $appel");
  $appel .= eregi_replace('&(submit|valider|PHPSESSID|(var_[^=&]*)|recalcul)=[^&]*',  '', $QUERY_STRING);
  $appel = eregi_replace('&[^=]*=','=',$appel);
  $hache = md5($appel);
  $use_cache = '';
  $headers_only = ($HTTP_SERVER_VARS['REQUEST_METHOD'] == 'HEAD');

  if ($headers_only || $HTTP_IF_MODIFIED_SINCE)
    {
      $r = spip_fetch_array(spip_query("
SELECT	naissance
FROM	spip_caches
WHERE	hache = 0x$hache"));
      $lastmodified = $r['naissance']; 
      $gmoddate = gmdate("D, d M Y H:i:s", $lastmodified);
      // Code inoprant avec des serveurs WEB traitant ce champ en amont.
     if ($HTTP_IF_MODIFIED_SINCE)
       {
	 $if_modified_since=ereg_replace(';.*$', '', $HTTP_IF_MODIFIED_SINCE);
	 $if_modified_since=trim(str_replace('GMT', '', $if_modified_since));
	 if ($if_modified_since == $gmoddate) {
	   http_status(304);
	   $headers_only = true;
	 }
       }
    }
  
 if ($headers_only)
   {
     Header("Last-Modified: ".$gmoddate." GMT");
     flush(); // rien  dire de plus
   }
 else
   {
     include_local ("inc-cache.php3");
     $lastmodified = time();
     // pas de cache si :
     // recalcul (par dfinition) 
     // ou recherche (trop couteux de mmoriser une recherche prcise)
     // ou si valeurs hors URL (i.e. POST) sauf Forum qui les traite  part
     if (($GLOBALS['recalcul'] != 'oui') && (!$var_recherche) &&
	 (empty($HTTP_POST_VARS) || $ajout_forum))
       $use_cache = ramener_cache($hache, 'page_obsolete', 'spip_caches');
     // $lastmodified a pu tre modifi par page_obsolete (beurk)
     $gmoddate = gmdate("D, d M Y H:i:s", $lastmodified);
     if (!$use_cache)
       {
	 $page = '';
    // Gestion '=chapo' (redirection)
    // + ne pas cacher si l'URL d'un article est demande avant sa publication
    // (une seule requete, deux usages)
	 if ($id_article = intval($id_article)) {
	   $row = spip_fetch_array(spip_query("
SELECT	chapo
FROM	spip_articles
WHERE	id_article='$id_article' AND statut='publie'
"));
	   if (substr($row['chapo'], 0, 1) == '=') {
	     include_ecrire('inc_texte.php3');
	
	     list(,$redirect) = extraire_lien(array('','','',substr($row['chapo'], 1)));
	     if ($redirect) // sinon les navigateurs pataugent
	       {
		 $redirect = 'Location: ' . addslashes($redirect);
	 // Normalement on devrait pouvoir mettre a en cache:
		 //	 $page = "<". "?php header(\"$redirect\"); ?" . ">";
	 // Mais, contrairement  ce que dit sa doc,
	 // PHP ne met pas toujours le http-status  302 dans ce cas.
	 // On est donc oblig de refuser la mise en cache:
		 header($redirect);
		 // et comme le flush ne suffit pas il faut carrment sortir !
		 exit;
	       }
	   }
	 }
	 if (!$page)
	   {
	     $code = calculer_page_globale($fond, $hache, $var_recherche);
	     $invalideurs = $code[1];
	     $page = $code[0];
	   }
	 ecrire_cache($appel, $hache, $page, $invalideurs, $delais);
       }
 if (!$page) $page = $use_cache;

 $admin = $HTTP_COOKIE_VARS['spip_admin'];
     // interdire au client de cacher un login, un admin ou un recalcul
 if (!$flag_dynamique && $recalcul != 'oui' && !$admin)
   $expire = gmdate("D, d M Y H:i:s", $lastmodified + $delais)." GMT";
 else {
  $expire = "0";
  Header("Cache-Control: no-cache,must-revalidate");
  Header("Pragma: no-cache");
 }
 Header("Expires: $expire");
 Header("Last-Modified: ".$gmoddate." GMT");
 Header("Content-Type: text/html; charset=".lire_meta('charset'));

  envoi_page($page, $admin, $use_cache);

  $rienfoutu = $use_cache;

// indexer ce qu'on vient d'envoyer si ce n'est pas dj fait

 if ((lire_meta('activer_moteur') == 'oui') && $db_ok) {
  if ($id_article AND (1 >= spip_num_rows(spip_query("
SELECT	id_article
FROM	spip_index_articles 
WHERE	id_article=$id_article
LIMIT 2
"))))
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('article', $id_article);
      $rienfoutu = false;
    }
  else { if ($id_auteur AND (1 >= spip_num_rows(spip_query("
SELECT	id_auteur
FROM	spip_index_auteurs
WHERE	id_auteur=$id_auteur
LIMIT 2
"))))
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('auteur', $id_auteur);
      $rienfoutu = false;
    }
  else { if ($id_breve AND (1 >= spip_num_rows(spip_query("
SELECT	id_breve
FROM	spip_index_breves
WHERE	id_breve=$id_breve
LIMIT 2
"))))
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('breve', $id_breve);
      $rienfoutu = false;
    }
  else { if ($id_mot AND (1 >= spip_num_rows(spip_query("
SELECT	id_mot
FROM	spip_index_mots
WHERE	id_mot=$id_mot
LIMIT 2
"))))
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('mot', $id_mot);
      $rienfoutu = false;
    }
  else { if ($id_rubrique AND (1 >= spip_num_rows(spip_query("
SELECT	id_rubrique
FROM	spip_index_rubriques
WHERE	id_rubrique=$id_rubrique
LIMIT 2
"))))
    {
      include_ecrire("inc_index.php3");
      indexer_objet('rubrique', $id_rubrique); 
      $rienfoutu = false;
    }
  }}}}}
   } // fin de if (headers_only)
// excuter les taches de fond si on n'a rien eu a recalculer
 if ($rienfoutu)
   include("inc-public-global.php3");
} // fin du defined
?>
